﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Diagnostics;
using FDK;

namespace StrokeStyleT
{
	class CAct演奏背景動画 : CActivity
	{
		public enum E種別 { 背景, サムネイル, サムネイル枠 }

		public override void Onリソースの作成( IntPtr hDevice )
		{
			#region [ 実行条件チェック ]
			//-----------------
			if( this.b活性化してない )
				return;
			//-----------------
			#endregion

			this.txBGVサムネイル枠 = new CTexture( hDevice, Folder.stgテーマファイル( @"ScreenPlay BGV thumbnail window.png" ) );

			base.Onリソースの作成( hDevice );
		}
		public override void Onリソースの解放()
		{
			#region [ 実行条件チェック ]
			//-----------------
			if( this.b活性化してない )
				return;
			//-----------------
			#endregion

			Global.tDisposeする( ref this.txBGVサムネイル枠 );

			base.Onリソースの解放();
		}
		public override void On描画( IntPtr hDevice )
		{
			throw new InvalidOperationException( "別の引数付き On描画( E種別 ) を使用すること。" );
		}
		public void On描画( IntPtr hDevice, E種別 e種別 )
		{
			#region [ 実行条件チェック ]
			//-----------------
			if( this.b活性化してない )
				return;
			//-----------------
			#endregion

			#region [ (A) サムネイル枠 ]
			//-----------------
			if( ( this.txBGVサムネイル枠 != null ) && ( e種別 == E種別.サムネイル枠 ) )
			{
				this.txBGVサムネイル枠.t2D描画( hDevice, Theme.演奏.rcBGVサムネイル.X - 8, Theme.演奏.rcBGVサムネイル.Y - 8 );
				return;
			}
			//-----------------
			#endregion
			#region [ (B) 背景 ]
			//-----------------
			if( e種別 == E種別.背景 )
			{
				Size szScreen = Theme.szウィンドウ;											// 表示最大枠＝論理画面サイズ
				Size szVideo = Global.Song.r現在演奏中のスコアの背景動画.sz画像サイズ;		// 画像サイズを取得。

				// 拡大率の小さい方に合わせることで画像の縦横比率を保つ。

				var vc拡大率 = new Vector3() {
					X = (float) szScreen.Width / (float) szVideo.Width,
					Y = (float) szScreen.Height / (float) szVideo.Height,
					Z = 1.0f,
				};
				vc拡大率.X = Math.Min( vc拡大率.X, vc拡大率.Y );
				vc拡大率.Y = vc拡大率.X;


				// 拡大率に合わせて画像をセンタリング。

				int w = (int) ( szVideo.Width * vc拡大率.X );
				int h = (int) ( szVideo.Height * vc拡大率.Y );
				int x = ( szScreen.Width - w ) / 2;
				int y = ( szScreen.Height - h ) / 2;


				// 描画。

				Global.Song.r現在演奏中のスコアの背景動画.t最新のサンプルを描画する( x, y, w, h );
			}
			//-----------------
			#endregion
			#region [ (C) サムネイル ]
			//-----------------
			if( e種別 == E種別.サムネイル )
			{
				Global.Song.r現在演奏中のスコアの背景動画.t最新のサンプルを描画する( Theme.演奏.rcBGVサムネイル );
			}
			//-----------------
			#endregion
		}

		protected CTexture txBGVサムネイル枠;
	}
}
